use tokio::{
    sync::{
	mpsc::{
	    error::SendError,
	},
    },
};
use std::{
    fmt,
};

#[derive(Debug)]
pub enum Error
{
    SendError,
    RecvError,
    Unknown,
}

impl std::error::Error for Error{}
impl fmt::Display for Error
{
    fn fmt(&self, f: &mut fmt::Formatter<'_>) -> fmt::Result
    {
	write!(f, "sync (fatal): ")?;
	match self {
	    Error::SendError => write!(f, "there was an mpsc send error"),
	    Error::RecvError => write!(f, "there was an mpsc recv error"),
	    _ => write!(f, "unknown error"),
	}
    }
}

impl<T> From<SendError<T>> for Error
{
    fn from(_er: SendError<T>) -> Self
    {
	Error::SendError
    }
}
